package com.muyu.domain.taskenum;

import lombok.extern.log4j.Log4j2;

/**
 * @PackageName:com.muyu.domain.taskenum
 * @ClassName:Priority
 * @Description:
 * @author: ￥陈思豪￥
 * @date: 2024/9/5 19:59
 */
@Log4j2
public enum Weight {
    //紧急
    URGENT(4),
    //高
    HIGH(3),
    //中
    MEDIUM(2),
    //低
    LOW(1);

    private final int weight;

    Weight(int weight) {
        this.weight = weight;
    }

    public int getWeight() {
        return weight;
    }

    public static Weight getWeight(int weight) {
        switch (weight){
            case 4:
                return URGENT;
            case 3:
                return HIGH;
            case 2:
                return MEDIUM;
            case 1:
                return LOW;
            default:
                log.info("{} is illegal, weight",weight);
                return null;

        }
    }
}
