package com.muyu.task.feign;

import com.muyu.common.core.domain.Result;
import com.muyu.domain.DataValue;
import com.muyu.task.feign.factory.DataValueClientFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * @PackageName:com.muyu.task.feign
 * @ClassName:dataValue
 * @Description:
 * @author: ￥陈思豪￥
 * @date: 2024/9/4 15:13
 */
//,fallback = TaskFeignFallback.class
@FeignClient(name = "cloud-source",fallbackFactory = DataValueClientFactory.class )
public interface DataValueClient {

    /**
     * 根据sql查询数据
     *
     * @param basicId
     * @param sql
     * @return
     */
    @PostMapping("/DataValue/findTableValue")
    public Result<List<List<DataValue>>> findTableValue(@RequestParam("basicId") Long basicId, @RequestParam("sql") String sql);

    /**
     * 根据sql查询数据条数
     *
     * @param basicId
     * @param sql
     * @return
     */
    @PostMapping("/DataValue/findCount")
    public Integer findCount(@RequestParam("basicId") Long basicId, @RequestParam("sql") String sql);

    //添加
    @PostMapping("/DataValue/addTable")
    public Result addTableDataValue(@RequestParam("basicId") Long basicId, @RequestParam("tableId") Long tableId, @RequestBody List<List<DataValue>> dataValue);


    //二维数组查询
    @PostMapping("/DataValue/findTableValueToArray")
    public Result<DataValue[][]> findTableValueToArray(@RequestParam("basicId") Long basicId, @RequestParam("sql") String sql, @RequestParam("one") Long one, @RequestParam("two") Integer two);


    //添加数据值
    @PostMapping("/product/addProduct")
    public Result addProduct(@RequestParam("basicId") Long basicId, @RequestParam("tableId") Long tableId, @RequestBody DataValue[][] listList);
}
