package com.muyu.task.feign.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.domain.DataValue;
import com.muyu.task.feign.DataValueClient;
import lombok.extern.log4j.Log4j2;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @PackageName:com.muyu.task.feign.factory
 * @ClassName:DataValueClientFactory
 * @Description:
 * @author: ￥陈思豪￥
 * @date: 2024/9/9 10:48
 */
@Log4j2
@Component
public class DataValueClientFactory implements FallbackFactory<DataValueClient> {
    @Override
    public DataValueClient create(Throwable cause) {
        return new DataValueClient() {
            @Override
            public Result<List<List<DataValue>>> findTableValue(Long basicId, String sql) {
                return Result.error("网络开小差");
            }

            @Override
            public Integer findCount(Long basicId, String sql) {
                return 111111111;
            }

            @Override
            public Result addTableDataValue(Long basicId, Long tableId, List<List<DataValue>> dataValue) {
                return Result.error("网络开小差");
            }

            @Override
            public Result<DataValue[][]> findTableValueToArray(Long basicId, String sql, Long one, Integer two) {
                return null;
            }

            @Override
            public Result addProduct(Long basicId, Long tableId, DataValue[][] listList) {
                return Result.error("网络开小差");
            }
        };
    }
}
