package com.muyu.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.muyu.common.core.domain.Result;
import com.muyu.domain.NodeRule;
import com.muyu.service.NodeRuleService;
import io.swagger.v3.oas.annotations.Operation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import static java.nio.file.Files.delete;

/**
 * @PackageName:com.muyu.controller
 * @ClassName:NodeRuleController
 * @Description:
 * @author: ￥陈思豪￥
 * @date: 2024/9/8 19:35
 */
@RestController
@RequestMapping("/nodeRule")
public class NodeRuleController {

    @Autowired
    private NodeRuleService nodeRuleService;

    @RequestMapping(path = "/addNodeRule", method = RequestMethod.POST)
    @Operation(summary = "添加任务", description = "根据传来的数据进行任务添加")
    public Result<String> addTask(@RequestBody NodeRule nodeRule) {
        QueryWrapper<NodeRule> wrapper = new QueryWrapper<>();
        wrapper.eq("node_id", nodeRule.getNodeId());
        wrapper.eq("task_id", nodeRule.getId());
        nodeRuleService.remove(wrapper);
        boolean save = nodeRuleService.save(nodeRule);
        if(!save){
            throw new RuntimeException("失败");
        }
        return Result.success(null,"成功");
    }
}
